-- core/screen.lua :: Basic screen manager. Use CScreen as a backend, and works
-- as an abstraction layer around CScreen.

--[[
  Copyright © 2019 Kazhnuz

  Permission is hereby granted, free of charge, to any person obtaining a copy of
  this software and associated documentation files (the "Software"), to deal in
  the Software without restriction, including without limitation the rights to
  use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  the Software, and to permit persons to whom the Software is furnished to do so,
  subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
]]

local ScreenManager = Object:extend()

local CScreen = require "libs.cscreen"

local SCREEN_HEIGHT = 240
local SCREEN_WIDTH  = 424

function ScreenManager:new(controller)
  self.controller = controller
  self.data       = self.controller.options.data.video
  self:applySettings()
  CScreen.init(SCREEN_WIDTH, SCREEN_HEIGHT, true)
  CScreen.setColor(0, 0, 0, 1)

  love.graphics.setDefaultFilter( "nearest", "nearest", 1 )
end

function ScreenManager:applySettings()
  self.data       = self.controller.options.data.video

  local flags = {}
  flags.vsync = self.data.vsync
  flags.borderless = (self.data.border == false)

  love.window.setMode(SCREEN_WIDTH * self.data.resolution, SCREEN_HEIGHT * self.data.resolution, flags)
  love.window.setFullscreen( self.data.fullscreen )

  local width, height = love.window.getMode()
  CScreen.update(width, height)
end

function ScreenManager:project(x, y)
  return CScreen.project(x, y)
end

function ScreenManager:getMousePosition()
  return CScreen.project(love.mouse.getX(), love.mouse.getY())
end

function ScreenManager:apply()
  CScreen.apply()
end

function ScreenManager:cease()
  CScreen.cease()
end

return ScreenManager
